diff --git a/libvips/foreign/jpeg2vips.c b/libvips/foreign/jpeg2vips.c
index f2726866e..3ac7c6eee 100644
--- a/libvips/foreign/jpeg2vips.c
+++ b/libvips/foreign/jpeg2vips.c
@@ -134,9 +134,9 @@
  */
 
 /*
- */
 #define DEBUG_VERBOSE
 #define DEBUG
+ */
 
 #ifdef HAVE_CONFIG_H
 #include <config.h>
@@ -341,6 +341,10 @@ readjpeg_open_input( ReadJpeg *jpeg )
 static void
 readjpeg_close_input( ReadJpeg *jpeg )
 {
+#ifdef DEBUG
+	printf( "readjpeg_close_input:\n" );
+#endif /*DEBUG*/
+
 	if( jpeg->eman.fp ) {
 		jpeg->seek_position = ftell( jpeg->eman.fp );
 		VIPS_FREEF( fclose, jpeg->eman.fp );
@@ -387,6 +391,10 @@ readjpeg_close_cb( VipsObject *object, ReadJpeg *jpeg )
 static void
 readjpeg_minimise_cb( VipsObject *object, ReadJpeg *jpeg )
 {
+#ifdef DEBUG
+	printf( "readjpeg_minimise_cb:\n" );
+#endif /*DEBUG*/
+
 	readjpeg_close_input( jpeg );
 }
 
diff --git a/test/Makefile.am b/test/Makefile.am
index 006665d5d..241981d01 100644
--- a/test/Makefile.am
+++ b/test/Makefile.am
@@ -1,5 +1,6 @@
 # don't run test_thumbnail.sh by default, it takes ages
 TESTS = \
+	test_descriptors.sh \
 	test_cli.sh \
 	test_formats.sh \
 	test_seq.sh \
@@ -8,6 +9,16 @@ TESTS = \
 SUBDIRS = \
 	test-suite 
 
+noinst_PROGRAMS = \
+	test_descriptors
+
+test_descriptors_SOURCES = \
+	test_descriptors.c
+
+AM_CPPFLAGS = -I${top_srcdir}/libvips/include @VIPS_CFLAGS@ @VIPS_INCLUDES@
+AM_LDFLAGS = @LDFLAGS@ 
+LDADD = @VIPS_CFLAGS@ ${top_builddir}/libvips/libvips.la @VIPS_LIBS@
+
 EXTRA_DIST = \
 	variables.sh.in \
 	test_cli.sh \
diff --git a/test/test_descriptors b/test/test_descriptors
new file mode 100755
index 000000000..0e0b2c0c3
--- /dev/null
+++ b/test/test_descriptors
@@ -0,0 +1,210 @@
+#! /bin/bash
+
+# test_descriptors - temporary wrapper script for .libs/test_descriptors
+# Generated by libtool (GNU libtool) 2.4.6 Debian-2.4.6-10
+#
+# The test_descriptors program cannot be directly executed until all the libtool
+# libraries that it depends on are installed.
+#
+# This wrapper script should never be moved out of the build directory.
+# If it is, it will not operate correctly.
+
+# Sed substitution that helps us do robust quoting.  It backslashifies
+# metacharacters that are still active within double-quoted strings.
+sed_quote_subst='s|\([`"$\\]\)|\\\1|g'
+
+# Be Bourne compatible
+if test -n "${ZSH_VERSION+set}" && (emulate sh) >/dev/null 2>&1; then
+  emulate sh
+  NULLCMD=:
+  # Zsh 3.x and 4.x performs word splitting on ${1+"$@"}, which
+  # is contrary to our usage.  Disable this feature.
+  alias -g '${1+"$@"}'='"$@"'
+  setopt NO_GLOB_SUBST
+else
+  case `(set -o) 2>/dev/null` in *posix*) set -o posix;; esac
+fi
+BIN_SH=xpg4; export BIN_SH # for Tru64
+DUALCASE=1; export DUALCASE # for MKS sh
+
+# The HP-UX ksh and POSIX shell print the target directory to stdout
+# if CDPATH is set.
+(unset CDPATH) >/dev/null 2>&1 && unset CDPATH
+
+relink_command=""
+
+# This environment variable determines our operation mode.
+if test "$libtool_install_magic" = "%%%MAGIC variable%%%"; then
+  # install mode needs the following variables:
+  generated_by_libtool_version='2.4.6'
+  notinst_deplibs=' ../libvips/libvips.la'
+else
+  # When we are sourced in execute mode, $file and $ECHO are already set.
+  if test "$libtool_execute_magic" != "%%%MAGIC variable%%%"; then
+    file="$0"
+
+# A function that is used when there is no print builtin or printf.
+func_fallback_echo ()
+{
+  eval 'cat <<_LTECHO_EOF
+$1
+_LTECHO_EOF'
+}
+    ECHO="printf %s\\n"
+  fi
+
+# Very basic option parsing. These options are (a) specific to
+# the libtool wrapper, (b) are identical between the wrapper
+# /script/ and the wrapper /executable/ that is used only on
+# windows platforms, and (c) all begin with the string --lt-
+# (application programs are unlikely to have options that match
+# this pattern).
+#
+# There are only two supported options: --lt-debug and
+# --lt-dump-script. There is, deliberately, no --lt-help.
+#
+# The first argument to this parsing function should be the
+# script's ../libtool value, followed by no.
+lt_option_debug=
+func_parse_lt_options ()
+{
+  lt_script_arg0=$0
+  shift
+  for lt_opt
+  do
+    case "$lt_opt" in
+    --lt-debug) lt_option_debug=1 ;;
+    --lt-dump-script)
+        lt_dump_D=`$ECHO "X$lt_script_arg0" | /bin/sed -e 's/^X//' -e 's%/[^/]*$%%'`
+        test "X$lt_dump_D" = "X$lt_script_arg0" && lt_dump_D=.
+        lt_dump_F=`$ECHO "X$lt_script_arg0" | /bin/sed -e 's/^X//' -e 's%^.*/%%'`
+        cat "$lt_dump_D/$lt_dump_F"
+        exit 0
+      ;;
+    --lt-*)
+        $ECHO "Unrecognized --lt- option: '$lt_opt'" 1>&2
+        exit 1
+      ;;
+    esac
+  done
+
+  # Print the debug banner immediately:
+  if test -n "$lt_option_debug"; then
+    echo "test_descriptors:test_descriptors:$LINENO: libtool wrapper (GNU libtool) 2.4.6 Debian-2.4.6-10" 1>&2
+  fi
+}
+
+# Used when --lt-debug. Prints its arguments to stdout
+# (redirection is the responsibility of the caller)
+func_lt_dump_args ()
+{
+  lt_dump_args_N=1;
+  for lt_arg
+  do
+    $ECHO "test_descriptors:test_descriptors:$LINENO: newargv[$lt_dump_args_N]: $lt_arg"
+    lt_dump_args_N=`expr $lt_dump_args_N + 1`
+  done
+}
+
+# Core function for launching the target application
+func_exec_program_core ()
+{
+
+      if test -n "$lt_option_debug"; then
+        $ECHO "test_descriptors:test_descriptors:$LINENO: newargv[0]: $progdir/$program" 1>&2
+        func_lt_dump_args ${1+"$@"} 1>&2
+      fi
+      exec "$progdir/$program" ${1+"$@"}
+
+      $ECHO "$0: cannot exec $program $*" 1>&2
+      exit 1
+}
+
+# A function to encapsulate launching the target application
+# Strips options in the --lt-* namespace from $@ and
+# launches target application with the remaining arguments.
+func_exec_program ()
+{
+  case " $* " in
+  *\ --lt-*)
+    for lt_wr_arg
+    do
+      case $lt_wr_arg in
+      --lt-*) ;;
+      *) set x "$@" "$lt_wr_arg"; shift;;
+      esac
+      shift
+    done ;;
+  esac
+  func_exec_program_core ${1+"$@"}
+}
+
+  # Parse options
+  func_parse_lt_options "$0" ${1+"$@"}
+
+  # Find the directory that this script lives in.
+  thisdir=`$ECHO "$file" | /bin/sed 's%/[^/]*$%%'`
+  test "x$thisdir" = "x$file" && thisdir=.
+
+  # Follow symbolic links until we get to the real thisdir.
+  file=`ls -ld "$file" | /bin/sed -n 's/.*-> //p'`
+  while test -n "$file"; do
+    destdir=`$ECHO "$file" | /bin/sed 's%/[^/]*$%%'`
+
+    # If there was a directory component, then change thisdir.
+    if test "x$destdir" != "x$file"; then
+      case "$destdir" in
+      [\\/]* | [A-Za-z]:[\\/]*) thisdir="$destdir" ;;
+      *) thisdir="$thisdir/$destdir" ;;
+      esac
+    fi
+
+    file=`$ECHO "$file" | /bin/sed 's%^.*/%%'`
+    file=`ls -ld "$thisdir/$file" | /bin/sed -n 's/.*-> //p'`
+  done
+
+  # Usually 'no', except on cygwin/mingw when embedded into
+  # the cwrapper.
+  WRAPPER_SCRIPT_BELONGS_IN_OBJDIR=no
+  if test "$WRAPPER_SCRIPT_BELONGS_IN_OBJDIR" = "yes"; then
+    # special case for '.'
+    if test "$thisdir" = "."; then
+      thisdir=`pwd`
+    fi
+    # remove .libs from thisdir
+    case "$thisdir" in
+    *[\\/].libs ) thisdir=`$ECHO "$thisdir" | /bin/sed 's%[\\/][^\\/]*$%%'` ;;
+    .libs )   thisdir=. ;;
+    esac
+  fi
+
+  # Try to get the absolute directory name.
+  absdir=`cd "$thisdir" && pwd`
+  test -n "$absdir" && thisdir="$absdir"
+
+  program='test_descriptors'
+  progdir="$thisdir/.libs"
+
+
+  if test -f "$progdir/$program"; then
+    # Add our own library path to LD_LIBRARY_PATH
+    LD_LIBRARY_PATH="/home/john/GIT/libvips/libvips/.libs:/home/john/vips/lib:$LD_LIBRARY_PATH"
+
+    # Some systems cannot cope with colon-terminated LD_LIBRARY_PATH
+    # The second colon is a workaround for a bug in BeOS R4 sed
+    LD_LIBRARY_PATH=`$ECHO "$LD_LIBRARY_PATH" | /bin/sed 's/::*$//'`
+
+    export LD_LIBRARY_PATH
+
+    if test "$libtool_execute_magic" != "%%%MAGIC variable%%%"; then
+      # Run the actual program with our arguments.
+      func_exec_program ${1+"$@"}
+    fi
+  else
+    # The program doesn't exist.
+    $ECHO "$0: error: '$progdir/$program' does not exist" 1>&2
+    $ECHO "This script is just a wrapper for $program." 1>&2
+    $ECHO "See the libtool documentation for more information." 1>&2
+    exit 1
+  fi
+fi
diff --git a/test/test_descriptors.c b/test/test_descriptors.c
index f8c32a6ea..d2740aadd 100644
--- a/test/test_descriptors.c
+++ b/test/test_descriptors.c
@@ -81,7 +81,7 @@ main( int argc, char **argv )
 
 	/* Clean up, and we should still just have three open.
 	 */
-	g_object_unref( x );
+	g_object_unref( image );
 	vips_shutdown();
 
 	if( count_files( fd_dir ) != n_files )
diff --git a/test/test_descriptors.sh b/test/test_descriptors.sh
new file mode 100755
index 000000000..17f762bb6
--- /dev/null
+++ b/test/test_descriptors.sh
@@ -0,0 +1,12 @@
+#!/bin/sh
+
+# test the various restartable loaders
+
+# set -x
+set -e
+
+. ./variables.sh
+
+if test_supported jpegload; then
+	./test_descriptors $image
+fi
diff --git a/test/test_formats.sh b/test/test_formats.sh
index 60a4ccccf..830f0e3fc 100755
--- a/test/test_formats.sh
+++ b/test/test_formats.sh
@@ -171,20 +171,6 @@ test_saver() {
 	echo "ok"
 }
 
-# test for file format supported
-test_supported() {
-	format=$1
-
-	if $vips $format > /dev/null 2>&1; then
-		result=0
-	else
-		echo "support for $format not configured, skipping test"
-		result=1
-	fi
-
-	return $result
-}
-
 test_format $image v 0
 if test_supported tiffload; then
 	test_format $image tif 0
